/*!
 * Copyright (c) 2017-2019 Cliqz GmbH. All rights reserved.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */
import { FiltersEngine, Request } from '@cliqz/adblocker';
/**
 * Create an instance of `Request` from `Electron.OnBeforeRequestDetails`.
 */
export declare function fromElectronDetails({ id, url, resourceType, referrer, webContentsId, }: Electron.OnHeadersReceivedListenerDetails | Electron.OnBeforeRequestListenerDetails): Request;
/**
 * Wrap `FiltersEngine` into a Electron-friendly helper class.
 */
export declare class ElectronBlocker extends FiltersEngine {
    enableBlockingInSession(ses: Electron.Session): void;
    disableBlockingInSession(ses: Electron.Session): void;
    private onIsMutationObserverEnabled;
    private onGetCosmeticFilters;
    private onHeadersReceived;
    private onBeforeRequest;
    private injectStyles;
}
export * from '@cliqz/adblocker';
