"use strict";
/*!
 * Copyright (c) 2017-present Cliqz GmbH. All rights reserved.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */
exports.__esModule = true;
var tslib_1 = require("tslib");
var tsmaz_1 = require("tsmaz");
var cosmetic_selector_1 = tslib_1.__importDefault(require("./codebooks/cosmetic-selector"));
var network_csp_1 = tslib_1.__importDefault(require("./codebooks/network-csp"));
var network_filter_1 = tslib_1.__importDefault(require("./codebooks/network-filter"));
var network_hostname_1 = tslib_1.__importDefault(require("./codebooks/network-hostname"));
var network_redirect_1 = tslib_1.__importDefault(require("./codebooks/network-redirect"));
var Compression = /** @class */ (function () {
    function Compression() {
        this.cosmeticSelector = new tsmaz_1.Smaz(cosmetic_selector_1["default"]);
        this.networkCSP = new tsmaz_1.Smaz(network_csp_1["default"]);
        this.networkRedirect = new tsmaz_1.Smaz(network_redirect_1["default"]);
        this.networkHostname = new tsmaz_1.Smaz(network_hostname_1["default"]);
        this.networkFilter = new tsmaz_1.Smaz(network_filter_1["default"]);
    }
    return Compression;
}());
exports["default"] = Compression;
//# sourceMappingURL=compression.js.map