/*!
 * Copyright (c) 2017-present Cliqz GmbH. All rights reserved.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */
import StaticDataView from './data-view';
var Config = /** @class */ (function () {
    function Config(_a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.debug, debug = _c === void 0 ? false : _c, _d = _b.enableCompression, enableCompression = _d === void 0 ? false : _d, _e = _b.enableHtmlFiltering, enableHtmlFiltering = _e === void 0 ? false : _e, _f = _b.enableMutationObserver, enableMutationObserver = _f === void 0 ? true : _f, _g = _b.enableOptimizations, enableOptimizations = _g === void 0 ? true : _g, _h = _b.integrityCheck, integrityCheck = _h === void 0 ? true : _h, _j = _b.loadCosmeticFilters, loadCosmeticFilters = _j === void 0 ? true : _j, _k = _b.loadGenericCosmeticsFilters, loadGenericCosmeticsFilters = _k === void 0 ? true : _k, _l = _b.loadNetworkFilters, loadNetworkFilters = _l === void 0 ? true : _l;
        this.debug = debug;
        this.enableCompression = enableCompression;
        this.enableHtmlFiltering = enableHtmlFiltering;
        this.enableMutationObserver = enableMutationObserver;
        this.enableOptimizations = enableOptimizations;
        this.integrityCheck = integrityCheck;
        this.loadCosmeticFilters = loadCosmeticFilters;
        this.loadGenericCosmeticsFilters = loadGenericCosmeticsFilters;
        this.loadNetworkFilters = loadNetworkFilters;
    }
    Config.deserialize = function (buffer) {
        return new Config({
            debug: buffer.getBool(),
            enableCompression: buffer.getBool(),
            enableHtmlFiltering: buffer.getBool(),
            enableMutationObserver: buffer.getBool(),
            enableOptimizations: buffer.getBool(),
            integrityCheck: buffer.getBool(),
            loadCosmeticFilters: buffer.getBool(),
            loadGenericCosmeticsFilters: buffer.getBool(),
            loadNetworkFilters: buffer.getBool()
        });
    };
    Config.prototype.getSerializedSize = function () {
        // NOTE: this should always be the number of attributes and needs to be
        // updated when `Config` changes.
        return 9 * StaticDataView.sizeOfBool();
    };
    Config.prototype.serialize = function (buffer) {
        buffer.pushBool(this.debug);
        buffer.pushBool(this.enableCompression);
        buffer.pushBool(this.enableHtmlFiltering);
        buffer.pushBool(this.enableMutationObserver);
        buffer.pushBool(this.enableOptimizations);
        buffer.pushBool(this.integrityCheck);
        buffer.pushBool(this.loadCosmeticFilters);
        buffer.pushBool(this.loadGenericCosmeticsFilters);
        buffer.pushBool(this.loadNetworkFilters);
    };
    return Config;
}());
export default Config;
//# sourceMappingURL=config.js.map