/*!
 * Copyright (c) 2017-present Cliqz GmbH. All rights reserved.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */
import { HTMLSelector } from './filters/cosmetic';
export declare function extractTagsFromHtml(html: string, tag: string): [Array<[number, string]>, string, string];
export declare function extractSelectorsFromRules(selectors: HTMLSelector[]): [string[], RegExp[]];
export declare function selectTagsToRemove(patterns: string[], regexps: RegExp[], tags: Array<[number, string]>): Array<[number, string]>;
export declare function removeTagsFromHtml(html: string, toRemove: Array<[number, string]>): string;
export default class StreamingHtmlFilter {
    private buffer;
    private readonly patterns;
    private readonly regexps;
    constructor(selectors: HTMLSelector[]);
    flush(): string;
    write(chunk: string): string;
}
